unit Espec;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OGLView,
  OpenGl, OGLClass, OGLCam, OGLLight, OGLCntrl, ExtCtrls;

type
  TForm1 = class(TForm)
    GL1: TOGLView;
    Camera1: TOGLCamera;
    Timer1: TTimer;
    procedure GL1Paint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Angulo:integer;

implementation

{$R *.DFM}

procedure DesenhaCubo;
begin

  glColor3f(0.8,0.6,0.1);
  glBegin(GL_POLYGON); // face posterior
    glNormal3f(0,0,1);
    glVertex3f(10.0, 10.0, 10.0);
    glVertex3f(-10.0, 10.0, 10.0);
    glVertex3f(-10.0, -10.0, 10.0);
    glVertex3f(10.0, -10.0, 10.0);
  glEnd;


  glBegin(GL_POLYGON);  // face frontal
    glNormal3f(0,0,-1);
    glVertex3f(10.0, 10.0, -10.0);
    glVertex3f(10.0, -10.0, -10.0);
    glVertex3f(-10.0, -10.0, -10.0);
    glVertex3f(-10.0, 10.0, -10.0);
  glEnd;

  glBegin(GL_POLYGON);  //  face lateral esquerda
    glNormal3f(-1,0,0);
    glVertex3f(-10.0, 10.0, 10.0);
    glVertex3f(-10.0, 10.0, -10.0);
    glVertex3f(-10.0, -10.0, -10.0);
    glVertex3f(-10.0, -10.0, 10.0);
  glEnd;

  glBegin(GL_POLYGON);   //  face lateral direita
    glNormal3f(1,0,0);
    glVertex3f(10.0, 10.0, 10.0);
    glVertex3f(10.0, -10.0, 10.0);
    glVertex3f(10.0, -10.0, -10.0);
    glVertex3f(10.0, 10.0, -10.0);
  glEnd;

  glBegin(GL_POLYGON);  //  face superior
    glNormal3f(0,1,0);
    glVertex3f(-10.0, 10.0, -10.0);
    glVertex3f(-10.0, 10.0, 10.0);
    glVertex3f(10.0, 10.0, 10.0);
    glVertex3f(10.0, 10.0, -10.0);
  glEnd;

  glBegin(GL_POLYGON);   //  face inferior
    glNormal3f(0,-1,0);
    glVertex3f(-10.0, -10.0, -10.0);
    glVertex3f(10.0, -10.0, -10.0);
    glVertex3f(10.0, -10.0, 10.0);
    glVertex3f(-10.0, -10.0, 10.0);
  glEnd;
end;

procedure DefineLuz;
const
  LuzAmbiente : Array[0..3] of GLfloat = (0.5, 0.5, 0.5, 1.0);
  LuzDifusa   : Array[0..3] of GLfloat = (0.4, 0.4, 0.4, 1.0);
  LuzEspecular: Array[0..3] of GLfloat = (1.0, 1.0, 1.0, 1.0);
  PosicaoLuz  : Array[0..3] of GLfloat = (30.0, 20.0, 60.0, 1.0);
  Especularidade: Array[0..3] of GLfloat = (1.0, 1.0, 1.0, 1.0);
begin
   // Habilita o uso de iluminao
  glEnable(GL_LIGHTING);

  // Ativa o uso da luz ambiente
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @LuzAmbiente);
  // Define os parametros da Luz nmero Zero
  glLightfv(GL_LIGHT0, GL_AMBIENT, @LuzAmbiente);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, @LuzDifusa  );
  glLightfv(GL_LIGHT0, GL_SPECULAR, @LuzEspecular  );
  glLightfv(GL_LIGHT0, GL_POSITION, @PosicaoLuz );
  glEnable(GL_LIGHT0);

  // Ativa o "Color Tracking"
  glEnable(GL_COLOR_MATERIAL);

  // Define a reflectancia do material
  glMaterialfv(GL_FRONT,GL_SPECULAR, @Especularidade);

  // Define a concentrao do brilho.
  // Quanto maior o valor do Segundo parametro, mais
  // concentrado ser o brilho. (Valores vlidos: de 0 a 128)
  glMateriali(GL_FRONT,GL_SHININESS,20);

end;

procedure TForm1.GL1Paint(Sender: TObject);
begin
  DefineLuz;
  glRotatef(Angulo,0,1,0);
  DesenhaCubo;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Angulo:= Angulo + 1;
  if Angulo = 360
  then Angulo := 0;
  GL1.InvalidateGL;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Angulo := 45;
end;

end.



